//--------------------------- BLINKING TEXT -----------------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//-----------------------------------------------------------------------
//
//  Suggested HTML Input:
/*
  <APPLET code="Blinking.class" width=600 height=40>
      <param name=FONT       value="Helvetica">
      <param name=STYLE      value="1">
      <param name=SIZE       value="24">

      <param name=MSG        value="By Your Command.">

      <param name=PauseIn    value="10">

      <param name=BG_Color   value="black">
      <param name=FG_Color   value="red">

      <param name=DeltaH     value="0">   // adjust the Horizontal msg pos
      <param name=DeltaV     value="-20"> // adjust the Verticle msg pos

      <CENTER><FONT SIZE=3>{If you can read this, your browser dosen`t support Java.}</FONT><BR>
      <FONT FACE="Helvetica" SIZE=7>I Liked Battlestar Galactica</FONT></CENTER><BR>
  </APPLET>
*/
//-----------------------------------------------------------------------

import java.applet.Applet;
import java.util.*;
import java.awt.*;

// ----------------------------------------------------------------------

public class Blinking extends java.applet.Applet implements Runnable {

    private boolean         Bool1,      debug = true ;
    public  Thread          myThread;
    private String          Message,    Delim = " ";
    private Font            Font1;
    private FontMetrics     fm;
    private int             fontHeight, pause,      iCount;
    private int             x,          y,          msgWidth;
    private Color           ColorBG,    ColorFG1,   ColorFG2;
    private Color           Color1[];
    private float           rDelta,     gDelta,     bDelta;
    private String          Word1[];
    private int             wLength[],  xLoc[];
    private float           rBlink,     rStay;

    // ------------------------------------------------------------------

    public void init() {

        setFont(getFontParam("FONT","Helvetica","STYLE",1,"SIZE",24));
        fm         = getFontMetrics(getFont());
        fontHeight = fm.getHeight();


        Message    = getStringParam("MSG"," ");
//          System.out.println(" Message = "+Message); //CCP
//      msgWidth   = Message.length();

        Word1      = new String[10];
        Color1     = new Color[10];
        xLoc       = new int[10];
        xLoc[0]    = 0;
        iCount     = 0;
        StringTokenizer st = new StringTokenizer(Message,", .;:!?-");
        while (st.hasMoreTokens()) {
            Word1[iCount]  = st.nextToken();
            xLoc[iCount+1] = xLoc[iCount] + fm.stringWidth(Word1[iCount] + " ");
            iCount++;
        }
        xLoc[iCount] = xLoc[iCount] - fm.stringWidth(" ");

        ColorBG    = getColorParam("BG_Color", "black");
        setBackground(ColorBG);
        ColorFG1   = getColorParam("FG_Color1", "red");
        ColorFG2   = getColorParam("FG_Color2", "blue");

        rDelta     = ColorFG2.getRed()   - ColorFG1.getRed();
        gDelta     = ColorFG2.getGreen() - ColorFG1.getGreen();
        bDelta     = ColorFG2.getBlue()  - ColorFG1.getBlue();

        rBlink     = getFloatParam("Blink", (float) 0.6, (float) 0.0, (float) 1.0);
        rStay      = getFloatParam("Stay",  (float) 0.5, (float) 0.0, (float) 1.0);


        int DEL_H  = getIntParam("DeltaH",0,-100,100);
        x          = DEL_H + (size().width - xLoc[iCount])/2;
        int DEL_V  = getIntParam("DeltaV",0,-100,100);
        y          = (size().height + fontHeight)/2 - DEL_V;

        pause      = getIntParam("PauseIn",100,10,500);

    }

    // ------------------------------------------------------------------

    public void paint(Graphics g) {

        for (int i=0; i < iCount; i++) { 
            g.setColor(Color1[i]);
            g.drawString(Word1[i], x + xLoc[i], y);
        }
    }

    // ------------------------------------------------------------------

    public void start() {
        if (!Bool1) {
            if (myThread == null) myThread = new Thread(this);
            myThread.start();
        }
    }

    //-------------------------------------------------------------------

    public void stop() {
        myThread = null;
        repaint();
    }

    //-------------------------------------------------------------------
                            /** @deprecated */

    public boolean mouseDown(Event event, int i, int j) {
        if (Bool1) {
            Bool1 = false;
            start();
        } else {
            Bool1 = true;
            stop();
        }
        return true;
    }

    // --------------------- implement Runnable -------------------------

    public void run() {	

        while (myThread != null) {

            for (int i=0; i < iCount; i++) { 

                float bb  = (float) Math.random();
                if (rStay < bb) {
                    float ra1 = (float) Math.random();
                    float ra2 = (float) Math.random();
                    float ra3 = (float) Math.random();
                    int rCol  = (int)(ColorFG1.getRed()   + rDelta*ra1);
                    int gCol  = (int)(ColorFG1.getGreen() + gDelta*ra2);
                    int bCol  = (int)(ColorFG1.getBlue()  + bDelta*ra3);

                    float aa  = (float) Math.random();

                    if (rBlink < aa) 
                         Color1[i] = new Color(rCol, gCol, bCol);
                    else Color1[i] = ColorBG;
                }
            } 

            try {
                myThread.sleep (pause);
            } catch (InterruptedException e) {
                e.printStackTrace();   // print error log
            }

            repaint();
        }
    }

    // ------------------------ getString -------------------------------

    public String getStringParam(String x, String def_X) {
        String str;
        str = getParameter(x);
        if (str == null) str = def_X;
        return str;
    }

    // ----------------------- getInteger -------------------------------

    public int getIntParam(String i, int def_I, int min_i, int max_i) {
        int i_in;
        try {
            i_in = Integer.parseInt(getParameter(i));
            if ((i_in < min_i)||(i_in > max_i)) throw new Exception();
        } catch (Exception e) {
//          System.out.println(i+" invalid; using default value: "+def_I);
            i_in = def_I;
        }	
        return i_in;
    }

    // ------------------------ getColor --------------------------------

    public Color getColorParam(String c, String def_C) {

        Color Color1 = Color.lightGray;      // default color
        if (def_C != null) {
            if      (def_C.equalsIgnoreCase("black"))     Color1 = Color.black;
            else if (def_C.equalsIgnoreCase("blue"))      Color1 = Color.blue;
            else if (def_C.equalsIgnoreCase("cyan"))      Color1 = Color.cyan;
            else if (def_C.equalsIgnoreCase("darkGray"))  Color1 = Color.darkGray;
            else if (def_C.equalsIgnoreCase("gray"))      Color1 = Color.gray;
            else if (def_C.equalsIgnoreCase("green"))     Color1 = Color.green;
            else if (def_C.equalsIgnoreCase("lightGray")) Color1 = Color.lightGray;
            else if (def_C.equalsIgnoreCase("magenta"))   Color1 = Color.magenta;
            else if (def_C.equalsIgnoreCase("orange"))    Color1 = Color.orange;
            else if (def_C.equalsIgnoreCase("pink"))      Color1 = Color.pink;
            else if (def_C.equalsIgnoreCase("red"))       Color1 = Color.red;
            else if (def_C.equalsIgnoreCase("white"))     Color1 = Color.white;
            else if (def_C.equalsIgnoreCase("yellow"))    Color1 = Color.yellow;
        }

        StringTokenizer st;
        String rgbDelim = ":,.";
        String c_str = getParameter(c);
//      System.out.println(" Color c_str = "+c_str); //CCP
        if (c_str != null) {
            st = new StringTokenizer(c_str, rgbDelim);
        } else return Color1;

        if      (c_str.equalsIgnoreCase("black"))     return Color.black;
        else if (c_str.equalsIgnoreCase("blue"))      return Color.blue;
        else if (c_str.equalsIgnoreCase("cyan"))      return Color.cyan;
        else if (c_str.equalsIgnoreCase("darkGray"))  return Color.darkGray;
        else if (c_str.equalsIgnoreCase("gray"))      return Color.gray;
        else if (c_str.equalsIgnoreCase("green"))     return Color.green;
        else if (c_str.equalsIgnoreCase("lightGray")) return Color.lightGray;
        else if (c_str.equalsIgnoreCase("magenta"))   return Color.magenta;
        else if (c_str.equalsIgnoreCase("orange"))    return Color.orange;
        else if (c_str.equalsIgnoreCase("pink"))      return Color.pink;
        else if (c_str.equalsIgnoreCase("red"))       return Color.red;
        else if (c_str.equalsIgnoreCase("white"))     return Color.white;
        else if (c_str.equalsIgnoreCase("yellow"))    return Color.yellow;

        else if (st.countTokens() == 3) {
            System.out.println(" Color number "); //CCP
            Integer r = new Integer(st.nextToken());
            Integer g = new Integer(st.nextToken());
            Integer b = new Integer(st.nextToken());
            System.out.println(" r,g,b = "+r+"  "+g+"  "+b); //CCP
            Color1    = new Color(r.intValue(), g.intValue(), b.intValue());
            System.out.println(" Color1 = "+Color1); //CCP
            return Color1;
            }
        return Color1;
    }

// ------------------------------ getFloat ------------------------------

    public float getFloatParam(String f, float def_F, float min_f, float max_f) {
        float ff;
        try {
            String f_str = getParameter(f);
            ff = Float.valueOf(f_str).floatValue();
            if ((ff < min_f)||(ff > max_f)) throw new Exception();
        } catch (Exception e) {
                System.out.println(f+" Invalid; using default value: "+def_F);
                ff = def_F;
        }	
        return ff;
    }

    // -------------------------- getFont  ------------------------------

    public Font getFontParam(String fnt, String def_Fnt, 
            String Style, int def_Style, String Size, int def_Size) {

        String font_Name  = getStringParam(fnt,   def_Fnt);
        int    font_Style = getIntParam   (Style, def_Style, 0, 3);
        int    font_Size  = getIntParam   (Size,  def_Size, 4, 100);

        return (new Font(font_Name, font_Style, font_Size));
    }

    // ------------------------------------------------------------------

}
